/*
        Copyright (c) 2004 on behalf of the EU EGEE Project:
        The European Organization for Nuclear Research (CERN),
        Istituto Nazionale di Fisica Nucleare (INFN), Italy
        Datamat Spa, Italy
        Centre National de la Recherche Scientifique (CNRS), France
        CS Systeme d'Information (CSSI), France
        Royal Institute of Technology, Center for Parallel Computers (KTH-PDC), Sweden
        Universiteit van Amsterdam (UvA), Netherlands
        University of Helsinki (UH.HIP), Finland
        University of Bergen (UiB), Norway
        Council for the Central Laboratory of the Research Councils (CCLRC), United Kingdom

        NumericException: an exception for wrong string representing numbers

        Authors: Alvise Dorigo <alvise.dorigo@pd.infn.it>
        Version info: $Id: NumericException.h,v 1.2 2006/04/26 09:46:34 adorigo Exp $
*/

#ifndef __NUMERICEX_H__
#define __NUMERICEX_H__

#include<exception>
#include<string>

namespace glite {
  namespace ce {
    namespace cream_client_api {
      namespace util {		
	class NumericException : public std::exception {
	  
	  std::string m_error_message;
	  
	public:
	  NumericException(const std::string& err_info) : m_error_message(err_info) {}
	  virtual ~NumericException() throw() {}
	  virtual const char* what() const throw() { return m_error_message.c_str(); }
	  
	};
      }
    }
  }
}

#endif
