/*
        Copyright (c) 2004 on behalf of the EU EGEE Project:
        The European Organization for Nuclear Research (CERN),
        Istituto Nazionale di Fisica Nucleare (INFN), Italy
        Datamat Spa, Italy
        Centre National de la Recherche Scientifique (CNRS), France
        CS Systeme d'Information (CSSI), France
        Royal Institute of Technology, Center for Parallel Computers (KTH-PDC), Sweden
        Universiteit van Amsterdam (UvA), Netherlands
        University of Helsinki (UH.HIP), Finland
        University of Bergen (UiB), Norway
        Council for the Central Laboratory of the Research Councils (CCLRC), United Kingdom

        CreamProxy_AcceptNewJobSubmissions: the implementation of AcceptNewJobSubmissions class for the CREAM PROXY
        
        Authors: Alvise Dorigo <alvise.dorigo@pd.infn.it>
        Version info: $Id: CreamProxy_AcceptNewJobSubmissions.cpp,v 1.2.4.1 2008/08/25 14:06:38 adorigo Exp $
*/

#include "CREAM_CLIENTH.h"
#include "CREAM_CLIENTStub.h"

#include "glite/ce/cream-client-api-c/CreamProxy_Impl.h"
#include "glite/ce/cream-client-api-c/creamApiLogger.h"

using namespace glite::ce::cream_client_api::soap_proxy;
using namespace std;

//______________________________________________________________________________
CreamProxy_AcceptNewJobSubmissions::CreamProxy_AcceptNewJobSubmissions( const bool set, const int timeout ) throw()
  : AbsCreamProxy( timeout ), m_set( set )
{}


//______________________________________________________________________________
void CreamProxy_AcceptNewJobSubmissions::execute( const std::string& serviceURL ) 
  throw(BaseException&,
	InvalidArgumentException&,
	GridProxyDelegationException&,
	JobSubmissionDisabledException&,
	GenericException&,
	//	AuthenticationException&,
	AuthorizationException&,
	DelegationException&,
	InternalException&,
	ConnectionTimeoutException&,
	auth_ex&,
	soap_ex&,
	soap_runtime_ex&)
{
  initSoap init(this);
  
  __CREAM__acceptNewJobSubmissionsResponse resp;
#ifdef DOPROFILE
  apiUtil::scoped_timer T("CreamProxy_ServiceInfo::execute-soap_call___CREAM__acceptNewJobSubmissions");
#endif  
  if(SOAP_OK != soap_call___CREAM__acceptNewJobSubmissions(m_soap,
							   serviceURL.c_str(),
							   NULL,    // soapAction
							   m_set,
							   resp))
    ExceptionFactory::raiseException(m_soap);  
}
