/*
        Copyright (c) 2004 on behalf of the EU EGEE Project:
        The European Organization for Nuclear Research (CERN),
        Istituto Nazionale di Fisica Nucleare (INFN), Italy
        Datamat Spa, Italy
        Centre National de la Recherche Scientifique (CNRS), France
        CS Systeme d'Information (CSSI), France
        Royal Institute of Technology, Center for Parallel Computers (KTH-PDC), Sweden
        Universiteit van Amsterdam (UvA), Netherlands
        University of Helsinki (UH.HIP), Finland
        University of Bergen (UiB), Norway
        Council for the Central Laboratory of the Research Councils (CCLRC), United Kingdom

        CreamProxy_Start: the implementation of JobStart class for the CREAM PROXY
        
        Authors: Alvise Dorigo <alvise.dorigo@pd.infn.it>
        Version info: $Id: CreamProxy_Start.cpp,v 1.13.4.1 2008/08/25 14:06:38 adorigo Exp $
*/

#include "CREAM_CLIENTH.h"
#include "CREAM_CLIENTStub.h"

#include "glite/ce/cream-client-api-c/CreamProxy_Impl.h"
#include "glite/ce/cream-client-api-c/ResultWrapper.h"
#include "glite/ce/cream-client-api-c/creamApiLogger.h"

using namespace glite::ce::cream_client_api::soap_proxy;
using namespace std;

//______________________________________________________________________________
CreamProxy_Start::CreamProxy_Start(  const JobFilterWrapper* filter, 
				     ResultWrapper *result,
				     const int timeout ) throw()
  : AbsCreamProxy( timeout), m_jobFilter( filter ), m_result( result )
{
}

//______________________________________________________________________________
void CreamProxy_Start::execute( const std::string& serviceURL ) 
  throw(BaseException&,
	InvalidArgumentException&,
	GridProxyDelegationException&,
	JobSubmissionDisabledException&,
	GenericException&,
	//	AuthenticationException&,
	AuthorizationException&,
	DelegationException&,
	InternalException&,
	ConnectionTimeoutException&,
	auth_ex&,
	soap_ex&,
	soap_runtime_ex&)
{
  initSoap init(this);
  CREAMTYPES__CommandResult tmp;
  
#ifdef DOPROFILE
  apiUtil::scoped_timer T("CreamProxy_Start::execute-soap_call___CREAM__JobStart");
#endif  
  if(SOAP_OK != soap_call___CREAM__JobStart(m_soap,
					    serviceURL.c_str(),
					    NULL,    // soapAction
					    (CREAMTYPES__JobFilter*)m_jobFilter, 
					    &tmp))
    ExceptionFactory::raiseException(m_soap);
  
  *(m_result) = tmp.result;
  
}
