/*
        Copyright (c) 2004 on behalf of the EU EGEE Project:
        The European Organization for Nuclear Research (CERN),
        Istituto Nazionale di Fisica Nucleare (INFN), Italy
        Datamat Spa, Italy
        Centre National de la Recherche Scientifique (CNRS), France
        CS Systeme d'Information (CSSI), France
        Royal Institute of Technology, Center for Parallel Computers (KTH-PDC), Sweden
        Universiteit van Amsterdam (UvA), Netherlands
        University of Helsinki (UH.HIP), Finland
        University of Bergen (UiB), Norway
        Council for the Central Laboratory of the Research Councils (CCLRC), United Kingdom

        CreamProxy_Suspend: the implementation of JobSuspend class for the CREAM PROXY
        
        Authors: Alvise Dorigo <alvise.dorigo@pd.infn.it>
        Version info: $Id: CreamProxy_Suspend.cpp,v 1.7.4.1 2008/08/25 14:06:38 adorigo Exp $
*/

#include "CREAM_CLIENTH.h"
#include "CREAM_CLIENTStub.h"

#include "glite/ce/cream-client-api-c/CreamProxy_Impl.h"
#include "glite/ce/cream-client-api-c/creamApiLogger.h"
#include "glite/ce/cream-client-api-c/JobInfoWrapper.h"
#include "glite/ce/cream-client-api-c/ResultWrapper.h"

using namespace glite::ce::cream_client_api::soap_proxy;
using namespace std;

//______________________________________________________________________________
CreamProxy_Suspend::CreamProxy_Suspend( const JobFilterWrapper* filter, 
					ResultWrapper* target,
					const int timeout ) throw()
  : AbsCreamProxy( timeout ), m_jobFilter( filter ), m_result( target )
{
}

//______________________________________________________________________________
void CreamProxy_Suspend::execute( const string& serviceAddress ) 
  throw(BaseException&,
	InvalidArgumentException&,
	GridProxyDelegationException&,
	JobSubmissionDisabledException&,
	GenericException&,
	//	AuthenticationException&,
	AuthorizationException&,
	DelegationException&,
	InternalException&,
	ConnectionTimeoutException&,
	auth_ex&,
	soap_ex&,
	soap_runtime_ex&)
{
  initSoap init(this);
  CREAMTYPES__CommandResult tmp;

#ifdef DOPROFILE
    apiUtil::scoped_timer T("CreamProxy_Suspend::execute-soap_call___CREAM__JobSuspend");
#endif  
    
    if(SOAP_OK != soap_call___CREAM__JobSuspend(m_soap,
						serviceAddress.c_str(),
						NULL,    // soapAction
						(CREAMTYPES__JobFilter*)m_jobFilter, 
						&tmp))
      {
	ExceptionFactory::raiseException(m_soap);
      }
  
//   vector<CREAMTYPES__JobId*>::const_iterator it;
  
//   for( it = tmp.jobIdList.begin(); it != tmp.jobIdList.end(); ++it )
//     {
//       m_result->jobIdList.push_back( new JobIdWrapper( **it ) );
//     }
//   for( it = tmp.jobNotFoundIdList.begin(); it != tmp.jobNotFoundIdList.end(); ++it )
//     {
//       m_result->jobNotFoundIdList.push_back( new JobIdWrapper( **it ) );
//     }
//   for( it = tmp.jobStatusNotCompatibleIdList.begin(); it != tmp.jobStatusNotCompatibleIdList.end(); ++it )
//     {
//       m_result->jobStatusNotCompatibleIdList.push_back( new JobIdWrapper( **it ) );
//     }

  *(m_result) = tmp.result;
}
