/*
        Copyright (c) 2004 on behalf of the EU EGEE Project:
        The European Organization for Nuclear Research (CERN),
        Istituto Nazionale di Fisica Nucleare (INFN), Italy
        Datamat Spa, Italy
        Centre National de la Recherche Scientifique (CNRS), France
        CS Systeme d'Information (CSSI), France
        Royal Institute of Technology, Center for Parallel Computers (KTH-PDC), Sweden
        Universiteit van Amsterdam (UvA), Netherlands
        University of Helsinki (UH.HIP), Finland
        University of Bergen (UiB), Norway
        Council for the Central Laboratory of the Research Councils (CCLRC), United Kingdom

        JobDescriptionWrapper: a wrapper for the new class JobDescription
	
        Authors: Alvise Dorigo <alvise.dorigo@pd.infn.it>
        Version info: $Id: JobDescriptionWrapper.cpp,v 1.2.4.1 2008/08/01 09:53:43 adorigo Exp $
*/

#include <glite/ce/cream-client-api-c/JobDescriptionWrapper.h>

using namespace glite::ce::cream_client_api::soap_proxy;
using namespace std;

//______________________________________________________________________________
JobDescriptionWrapper::JobDescriptionWrapper(const std::string& _jdl,
					     const std::string& _delegationId,
					     const std::string& _delegationProxy,
					     const std::string& _leaseId,
					     const bool         _autostart,
					     const std::string& _descId) throw()
{
  delegationId     = NULL;
  delegationProxy  = NULL;
  leaseId          = NULL;
  jobDescriptionId = NULL;
  
  
  JDL              = _jdl;
  
  if(!_delegationId.empty())
    delegationId     = new std::string( _delegationId );
  
  if(!_delegationProxy.empty())
    delegationProxy  = new std::string( _delegationProxy );
  
  if(! _leaseId.empty())
    leaseId          = new std::string( _leaseId );
  
  autoStart        = _autostart;
  
  if(!_descId.empty())
    jobDescriptionId = new std::string(_descId);
  
}

JobDescriptionWrapper::~JobDescriptionWrapper( ) throw()
{
  //delete JDL;
  delete delegationId;    delegationId=0;
  delete delegationProxy; delegationProxy=0;
  delete leaseId;         leaseId=0;
  delete jobDescriptionId;jobDescriptionId=0;
}

//______________________________________________________________________________	    
// JobDescriptionWrapper::JobDescriptionWrapper( const CREAMTYPES__JobDescription& jd ) throw()
// {
//   JDL              = jd.JDL;
//   delegationId     = NULL;
//   delegationProxy  = NULL;
//   leaseId          = NULL;
//   jobDescriptionId = NULL;
  
  
//   if( jd.delegationId )
//     delegationId    = new std::string( *jd.delegationId );
  
//   if( jd.delegationProxy )
//     delegationProxy = new std::string( *jd.delegationProxy );
  
//   if( jd.leaseId )
//     leaseId         = new std::string( *jd.leaseId );
  
//   if( jd.jobDescriptionId )
//     jobDescriptionId= new std::string( *jd.jobDescriptionId );
  
//   autoStart         = jd.autoStart;
  
// }
