/*
        Copyright (c) 2004 on behalf of the EU EGEE Project:
        The European Organization for Nuclear Research (CERN),
        Istituto Nazionale di Fisica Nucleare (INFN), Italy
        Datamat Spa, Italy
        Centre National de la Recherche Scientifique (CNRS), France
        CS Systeme d'Information (CSSI), France
        Royal Institute of Technology, Center for Parallel Computers (KTH-PDC), Sweden
        Universiteit van Amsterdam (UvA), Netherlands
        University of Helsinki (UH.HIP), Finland
        University of Bergen (UiB), Norway
        Council for the Central Laboratory of the Research Councils (CCLRC), United Kingdom

        JobStatusWrapper: a wrapper for the new class Status
        
        Authors: Alvise Dorigo <alvise.dorigo@pd.infn.it>
        Version info: $Id: JobStatusWrapper.cpp,v 1.1 2008/01/29 15:44:50 adorigo Exp $
*/

#include <glite/ce/cream-client-api-c/JobStatusWrapper.h>

using namespace std;
using namespace glite::ce::cream_client_api::soap_proxy;

//______________________________________________________________________________
void JobStatusWrapper::set( const CREAMTYPES__Status* aStatus ) throw()
{
  
  if (aStatus->jobId)
    jobId = new JobIdWrapper( aStatus->jobId );
  else
    jobId = 0;
  
  name = aStatus->name;
  timestamp = aStatus->timestamp;
  
  if(aStatus->exitCode)
    exitCode = new std::string( *aStatus->exitCode );
  else
    exitCode = 0;
  
  if(aStatus->failureReason)
    failureReason = new std::string( *aStatus->failureReason );
  else
    failureReason = 0;
  
  if(aStatus->description)
    description   = new std::string( *aStatus->description );
  else
    description = 0;
}

//______________________________________________________________________________
JobStatusWrapper::JobStatusWrapper( const JobIdWrapper& aJob, 
					 const std::string& name,
					 const time_t timestamp, 
					 const std::string& exitCode,
					 const std::string& failureReason,
					 const std::string& description) throw()
{
  this->jobId = new JobIdWrapper( aJob );
  this->name = name;
  this->timestamp = timestamp;
  
  if( !exitCode.empty() )
    this->exitCode      = new std::string( exitCode );
  else
    this->exitCode = 0;
  
  if( !failureReason.empty() )
    this->failureReason = new std::string( failureReason );
  else
    this->failureReason = 0;
  
  if(!description.empty())
    this->description   = new std::string( description );
  else
    this->description = 0;
}
