/*
        Copyright (c) 2004 on behalf of the EU EGEE Project:
        The European Organization for Nuclear Research (CERN),
        Istituto Nazionale di Fisica Nucleare (INFN), Italy
        Datamat Spa, Italy
        Centre National de la Recherche Scientifique (CNRS), France
        CS Systeme d'Information (CSSI), France
        Royal Institute of Technology, Center for Parallel Computers (KTH-PDC), Sweden
        Universiteit van Amsterdam (UvA), Netherlands
        University of Helsinki (UH.HIP), Finland
        University of Bergen (UiB), Norway
        Council for the Central Laboratory of the Research Councils (CCLRC), United Kingdom

        ServiceInfoWrapper: a wrapper for the new class ServiceInfo
        
        Authors: Alvise Dorigo <alvise.dorigo@pd.infn.it>
        Version info: $Id: ServiceInfoWrapper.cpp,v 1.1 2008/02/22 09:29:50 adorigo Exp $
*/

#include <glite/ce/cream-client-api-c/ServiceInfoWrapper.h>

using namespace std;
using namespace glite::ce::cream_client_api::soap_proxy;

//______________________________________________________________________________
void ServiceInfoWrapper::reset( void ) throw()
{
  if(description) {
    delete description;
    description = 0;
  }
  if(status) {
    delete status;
    status = 0;
  }
  std::vector<CREAMTYPES__Property*>::const_iterator it;
  for(it=property.begin(); it!=property.end(); ++it)
    if(*it)
      delete(*it);
  property.clear(); 
  std::vector<CREAMTYPES__ServiceMessage*>::const_iterator sit;
  for(sit=message.begin(); sit!=message.end(); ++sit)
    if(*sit)
      delete(*sit);
  message.clear();
}

//______________________________________________________________________________
void ServiceInfoWrapper::set(const CREAMTYPES__ServiceInfo& aServ) throw()
{
  
  this->interfaceVersion = aServ.interfaceVersion;
  this->serviceVersion   = aServ.serviceVersion;
  this->startupTime      = aServ.startupTime;
  this->doesAcceptNewJobSubmissions = aServ.doesAcceptNewJobSubmissions;
  
  std::vector<CREAMTYPES__Property*>::const_iterator it;
  
  for(it=aServ.property.begin(); it!=aServ.property.end(); ++it)
    {
      CREAMTYPES__Property* tmp = new CREAMTYPES__Property();
      tmp->value = (*it)->value;
      tmp->name  = (*it)->name;
      this->property.push_back(tmp);
    }
  
  if(aServ.description) {
    this->description = new std::string( *aServ.description );
  } else this->description = NULL;
  
  if(aServ.status) {
    this->status = new std::string( *aServ.status );
  } else this->status = NULL;
  
  
  std::vector<CREAMTYPES__ServiceMessage*>::const_iterator sit;
  
  for(sit=aServ.message.begin(); sit!=aServ.message.end(); ++it)
    {
      CREAMTYPES__ServiceMessage* tmp = new CREAMTYPES__ServiceMessage();
      tmp->type      = (*sit)->type;
      tmp->message   = (*sit)->message;
      tmp->timastamp = (*sit)->timastamp;
      this->message.push_back(tmp);
    }
}
