#include "glite/ce/cream-client-api-c/cream_client_soapStub.h"
#include "glite/ce/cream-client-api-c/Status.h"
#include "glite/ce/cream-client-api-c/job_statuses.h"

using namespace std;

namespace soapProxy = glite::ce::cream_client_api::soap_proxy;
namespace job_states = glite::ce::cream_client_api::job_statuses;

//______________________________________________________________________________
soapProxy::Status::~Status()
{
}

//______________________________________________________________________________
soapProxy::Status::Status(creamtypes__Status* status) {
  if(!status) return;
  m_name = status->name;
  m_timestamp = status->timestamp;
  if( status->exitCode )
    m_exitCode = *(status->exitCode);
  else
    m_exitCode = "";
  if( status->failureReason )
    m_failureReason = *(status->failureReason);
  else
    m_failureReason = "";
  if( status->jobId )
    m_jobId = *(status->jobId);
  else
    m_jobId = "";
}

//______________________________________________________________________________
void soapProxy::Status::print( const int level ) const
{
    printf("\n****** JobID=[%s]\n", m_jobId.c_str() );
    printf("\tStatus        = [%s]\n", m_name.c_str());
    if(job_states::isFinished( job_states::getStatusNum(m_name) )) {
      printf("\tExitCode      = [%s]\n", m_exitCode.c_str());
      if(job_states::isFailed( job_states::getStatusNum(m_name) ))
        printf("\tFailureReason = [%s]\n", m_failureReason.c_str());
    }
}
